ifndef aiFPS_wdl;
define aiFPS_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 5.0
// engineReq: 6.4
// date: 061011
//
//
// title: Simple FPS AIs (01)
// class: AI
// type: USER
// image: aiFPS01.pcx
// help: Simple First Person Shooter AIs.
//
// needs: gid01.wdl
// needs: fxGore01.wdl
// needs: bipedPhy01.wdl, bipedAnim01.wdl, bipedSnd01.wdl
// needs: gid01.wdl, trigger00.wdl, particle00.wdl, weaponfx00.wdl, weapons00.wdl
// needs: plSelect.wdl
//
// external:
//
// prefix: aiFPS01_
// idcode: 029
//

// ENDHEADER
// ---------------------------------------------------------------------



// enable: Display AI health?
// id: 1
//define	aiFPS01_show_health;

string 	aiFPS01_str[10];

//----------------------------------------------------------------------
// section: Ranges

// entry: Minimum close range
// help: The minimum range (in quants) that the AI will try to maintain from the player.
// id: 2
define	aiFPS01_min_range = 150;

// entry: Alert Range
// help: Range (quants) that an alerted AI will 'call' for help in
// id: 3
define	aiFPS01_alert_range = 1000;



//----------------------------------------------------------------------
// section: Gore

// enable: Display Blood?
// help: Do "Blood Spray" when AI takes health damage.
// id: 4
define	aiFPS01_show_blood;

// enable: Display Sparks?
// help: Do "Spark Effect" when AI takes armor damage.
// id: 5
define	aiFPS01_show_sparks;




// forces used to control AI
define	_cur_force_x__029, SKILL61;
define	_cur_force_y__029, SKILL62;
define	_cur_force_z__029, SKILL63;
define	_cur_ang_force_pan__029, SKILL64;
define	_cur_ang_force_tilt__029, SKILL65;
define	_cur_ang_force_roll__029, SKILL66;



///////////////////////////////////////////////////////////////////////
// Entity skill & flag definitions

define   _weapon_id__029,SKILL18;		// id of weapon used
define	_weapon_vertex__029,SKILL19;  // model vertex that weapon fire comes from
define	_weapon_acc_mod__029, SKILL20;// accuracy modifier added (or removed) and reload modfifier (acc.ticks)
define	_weapon_reload_mod__029, SKILL42;	// reload time modifier

define	_reload_ticks__029, SKILL41;	// time left to reload weapon for next shot (ticks)


define	_fov__029,SKILL7;					// field of view (range.deg)
define 	_hearing__029,SKILL8;			// 'hearing' range

define 	_sight_range__029,SKILL36;		// sight range of the guard


define	_height__029,SKILL60;				// flying height used for hovering AIs

// internal skills
define _ai_state__029,SKILL40;		// state of the AI
define _aiFPS01_state_wait,0;				// wait state
define _aiFPS01_state_attack,1;			// attack (sees player)
define _aiFPS01_state_die,2;				// dying
define _aiFPS01_state_hunt,3;				// knows player is there, does not see them



define _explode__029,FLAG5;		// AI "explodes" on death.

// Used for Performance report (collision)
//define	aiFPS01_perform_report;
ifdef	aiFPS01_perform_report;
var aiFPS01_elapsed;
var aiFPS01_calls;
var aiFPS01_trace_calls;
var aiFPS01_look_elapsed;
var aiFPS01_look_calls;

var aiFPS01_event_calls;
var aiFPS01_event_time;
var aiFPS01_fire_calls;
var aiFPS01_fire_time;
var aiFPS01_scan_calls;
var aiFPS01_scan_time;



string aiFPS01_perform_str[60];

starter AIFPS01_perform
{
	while(1)
	{
		diag("\n\nAIFPS Calls: ");
		str_for_num(aiFPS01_perform_str,aiFPS01_calls);
		diag(aiFPS01_perform_str);
		diag(" = ");
		str_for_num(aiFPS01_perform_str,aiFPS01_trace_calls);
		diag(aiFPS01_perform_str);

		diag(" Total t: ");
		str_for_num(aiFPS01_perform_str,time_actions);
		diag(aiFPS01_perform_str);

		diag(" Trace t: ");
 		str_for_num(aiFPS01_perform_str,aiFPS01_elapsed/1000);	// convert from microsec to ms
		diag(aiFPS01_perform_str);
		if(time_actions > 0)   // avoid div by zero
		{
			diag(" (");
			str_for_num(aiFPS01_perform_str,(aiFPS01_elapsed/time_actions)/10);
			diag(aiFPS01_perform_str);
			diag("%)");
		}

 		diag("\n Look Calls: ");
		str_for_num(aiFPS01_perform_str,aiFPS01_look_calls);
		diag(aiFPS01_perform_str);

		diag(" Look t: ");
 		str_for_num(aiFPS01_perform_str,aiFPS01_look_elapsed/1000);	// convert from microsec to ms
		diag(aiFPS01_perform_str);
		if(time_actions > 0)   // avoid div by zero
		{
			diag(" (");
			str_for_num(aiFPS01_perform_str,(aiFPS01_look_elapsed/time_actions)/10);
			diag(aiFPS01_perform_str);
			diag("%)");
		}

 		diag(" Scan Calls: ");
		str_for_num(aiFPS01_perform_str,aiFPS01_scan_calls);
		diag(aiFPS01_perform_str);

		diag(" Scan t: ");
 		str_for_num(aiFPS01_perform_str,aiFPS01_scan_time/1000);	// convert from microsec to ms
		diag(aiFPS01_perform_str);
		if(time_actions > 0)   // avoid div by zero
		{
			diag(" (");
			str_for_num(aiFPS01_perform_str,(aiFPS01_scan_time/time_actions)/10);
			diag(aiFPS01_perform_str);
			diag("%)");
		}

 		diag(" Event Calls: ");
		str_for_num(aiFPS01_perform_str,aiFPS01_event_calls);
		diag(aiFPS01_perform_str);

		diag(" Event t: ");
 		str_for_num(aiFPS01_perform_str,aiFPS01_event_time/1000);	// convert from microsec to ms
		diag(aiFPS01_perform_str);
		if(time_actions > 0)   // avoid div by zero
		{
			diag(" (");
			str_for_num(aiFPS01_perform_str,(aiFPS01_event_time/time_actions)/10);
			diag(aiFPS01_perform_str);
			diag("%)");
		}

 		diag(" Fire Calls: ");
		str_for_num(aiFPS01_perform_str,aiFPS01_fire_calls);
		diag(aiFPS01_perform_str);

		diag(" Fire t: ");
 		str_for_num(aiFPS01_perform_str,aiFPS01_fire_time/1000);	// convert from microsec to ms
		diag(aiFPS01_perform_str);
		if(time_actions > 0)   // avoid div by zero
		{
			diag(" (");
			str_for_num(aiFPS01_perform_str,(aiFPS01_fire_time/time_actions)/10);
			diag(aiFPS01_perform_str);
			diag("%)");
		}



		sleep(1);
		aiFPS01_calls = 0;	// reset counters
		aiFPS01_trace_calls = 0;
		aiFPS01_elapsed = 0;	// reset timer
		aiFPS01_look_elapsed = 0;
		aiFPS01_look_calls = 0;
		aiFPS01_event_calls = 0;
		aiFPS01_event_time = 0;
		aiFPS01_fire_calls = 0;
		aiFPS01_fire_time = 0;
		aiFPS01_scan_calls = 0;
		aiFPS01_scan_time = 0;
		wait(1);
	}


}

endif;


//-----------------------------------------------------------------------
// PathFollow Section

// path skills
define _path_node__029, SKILL53;        // cur target node
define _path_vec__029, SKILL54;         // cur target pos
define _path_vec_x__029, SKILL54;
define _path_vec_y__029, SKILL55;
define _path_vec_z__029, SKILL56;

var	aifps01_path_skills[6];	// used to store the skills of the current path


// Path node skills are used as follows:
//  0: behavior
//		0 - move along next path (stored in param1), if param1 == 0, use path 1.
//		1 - wait for the amount of time in param2, then behave like behavior 0 above
//	 1-4: parameters for behaviors
//	 5: Entity handle (or 0 if nobody is using this node).



////////////////////////////////////////////////////////////////////////


// Desc: move along next path (stored in param2), if param2 == 0, use path 1.
//
// uses: temp                -> undef
//			aifps01_path_skills -> set to the skills of current node
// 		my._path_node__029  -> set to id of current node
//			my._path_vec__029   -> undef
//
// mods: temp                -> undef
//			aifps01_path_skills -> changed to skills of next node
// 		my._path_node__029  -> chaged to id of next node
//			my._path_vec__029   -> changed to position(x,y,z) of next node
//
// return 0 if end of the path
//			 1 if legal path found
//			 2 if next node is "in use"
function	AIFPS01_PathNext()
{

	// select which path to use
	if(aifps01_path_skills[1] == 0)
	{
		my._path_node__029 = path_nextnode(my,my._path_node__029,1);
	}
	else
	{
		// use the path stored in the param1
		my._path_node__029 = path_nextnode(my,my._path_node__029,aifps01_path_skills[1]);
	}


	if(my._path_node__029 != 0)
	{
		// set target vector to target node
		path_getnode(my,my._path_node__029,my._path_vec__029,aifps01_path_skills);

		// if somebody is using this node, return "in use" value
		if(aifps01_path_skills[5] != 0)
		{
			return(2); // next node in use
		}

		// set path as "in use" by this entity
		aifps01_path_skills[5] = handle(my);
		path_setnode(my,my._path_node__029,my._path_vec__029,aifps01_path_skills);
		return(1);
	}

	return(0);  // end of path
}


// Desc: action to preform on reaching a node
//
// return: 1 if we should continue pathfollowing
//			  0 if we should stop pathfollowing
function	AIFPS01_PathOnNode()
{
	var	old_node;
	old_node = my._path_node__029;

	// get skills for the current node
	path_getnode(my,old_node,temp,aifps01_path_skills);

	// switch on node_skills[0]
	if(aifps01_path_skills[0] == 1)
	{
		my._path_node__029 = 0;	// not following path for a while
		sleep(aifps01_path_skills[2]);	// time out
		my._path_node__029 = old_node;	// continue follow

		// go to next node following path in node_skills[1]
		temp = AIFPS01_PathNext();
	}
	else  // default action (node_skills[0] == 0)
	{
		// go to next node following path in node_skills[1]
		temp = AIFPS01_PathNext();
	}

	// handle temp value
	if(temp == 2)	// next node is in use
	{
//		breakpoint;
		temp=temp;
	}

	// clear this node for use...
	path_getnode(my,old_node,temp,aifps01_path_skills);
	aifps01_path_skills[5] = 0;
	path_setnode(my,old_node,temp,aifps01_path_skills);

	return(1);	// continue following node
}



//------------------------------------------------------------------------


////////////////////////////////////////////////////////////////////////
// Desc: pan to face a vector
function	AIFPS01_PanTo(panTo)
{
	panTo = ang(panTo-my.pan);

	// turn to face target angle
	if(panTo > my._max_ang_force_pan__003*time_step)
	{
		// turn anti-clockwise
		vec_set(my._cur_ang_force_pan__029,vector(my._max_ang_force_pan__003*time_step,0,0));
	}
	else
	{
		if(panTo < -my._max_ang_force_pan__003*time_step)
		{
			// turn anti-clockwise
			vec_set(my._cur_ang_force_pan__029,vector(-my._max_ang_force_pan__003*time_step,0,0));
		}
		else
		{
			// turn "exactly" to
			vec_set(my._cur_ang_force_pan__029,vector(panTo,0,0));
		}


	}
}



// trace front, left, right
// if front collision
//		turn towards furthest trace (left or right)
//	if front collision 'close'
//		slow speed to avoid collision
//	if left trace < critical distance
//		step right
// if right trace < critical distance
//		step left


define	aiFPS01_lookahead = 100;
define	aiFPS01_checkside = 35;

// Desc: Move along the pan given using the force given while doing basic
//     obstacle avoidance.
function aiFPS01_Move(targ_pan, targ_force)
{
// trace front, left, right
	var	col_dist[3];
	var	target_vec[3];

ifdef	aiFPS01_perform_report;
  timer(); // reset timer
  aiFPS01_calls += 1;	// reset counter
  aiFPS01_trace_calls += 1;
endif;
	// Trace Ahead...
	vec_set(target_vec,vector(aiFPS01_lookahead,0,0));
	vec_rotate(target_vec,vector(targ_pan,0,0));
	vec_add(target_vec,my.x);	// target_vec is the point we want to head towards

	trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS;// + USE_BOX;
	col_dist[0] = c_trace(my.x,target_vec,trace_mode);
	if(0 == trace_hit) // 0-if nothing hit
	{
		// Clear to the Front
		AIFPS01_PanTo(temp.pan);  // turn
		vec_set(my._cur_force_x__029,vector(targ_force,0,0)); // move forward
ifdef	aiFPS01_perform_report;
  aiFPS01_elapsed += timer(); // processor time used
endif;
		return;
	}

	// Trace Left...
	vec_set(target_vec,vector(aiFPS01_lookahead,0,0));
	vec_rotate(target_vec,vector(targ_pan+aiFPS01_checkside,0,0));
	vec_add(target_vec,my.x);	// target_vec is the point to the left
	trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS;// + USE_BOX;
	col_dist[1] = c_trace(my.x,target_vec,trace_mode);
	if(0 == trace_hit) // 0-if nothing hit
	{
		col_dist[1] = aiFPS01_lookahead + 1;
	}

	// Trace Right...
	vec_set(target_vec,vector(aiFPS01_lookahead,0,0));
	vec_rotate(target_vec,vector(targ_pan-aiFPS01_checkside,0,0));
	vec_add(target_vec,my.x);	// target_vec is the point to the left
	trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS;// + USE_BOX;
	col_dist[2] = c_trace(my.x,target_vec,trace_mode);
	if(0 == trace_hit) // 0-if nothing hit
	{
		col_dist[2] = aiFPS01_lookahead + 1;
	}
ifdef	aiFPS01_perform_report;
  aiFPS01_trace_calls += 2;
endif;


	// which is "more clear"
	if( col_dist[1] < col_dist[2] )    // wall closer to left then right
	{
		//AIFPS01_PanTo(temp.pan - aiFPS01_checkside);  // turn right
		AIFPS01_PanTo(temp.pan);  // turn
		vec_set(my._cur_force_x__029,vector(targ_force/2,-targ_force/2,0)); // move forward & right
ifdef	aiFPS01_perform_report;
  aiFPS01_elapsed += timer(); // processor time used
endif;
		return;
	}


	//AIFPS01_PanTo(temp.pan + aiFPS01_checkside);  // turn left
 	AIFPS01_PanTo(temp.pan);  // turn
	vec_set(my._cur_force_x__029,vector(targ_force/2,targ_force/2,0)); // move forward  & left
ifdef	aiFPS01_perform_report;
  aiFPS01_elapsed += timer(); // processor time used
endif;
	return;



}


// Desc: Fire a launcher weapon
function	AIFPS01_LauncherFire()
{
	var	weap_offset;

	weap_offset = ((my._weapon_id__029-100)*weapLaunch00_weap_field_count);
	if(weap_offset < 0) { return(0); }


	if(my._weapon_vertex__029 <= 0)
	{
		// use model center
		vec_set(weapons00_from_vec,my.x);
	}
	else
	{
		// use weapon vertex
		vec_for_vertex(weapons00_from_vec, my, my._weapon_vertex__029);
	}

	// calculate vector to player
	vec_diff(temp,plSelect_curr_ent.x,weapons00_from_vec);
	vec_to_angle(weapons00_to_vec,temp);

	// fx comes from the same area shoot comes from
	vec_set(weapons00_fx_vec,weapons00_from_vec);

	// reload time
	my._reload_ticks__029 = weapLaunch00_template[weap_offset + weapLaunch00_weap_cycle] + my._weapon_reload_mod__029;

	YOU = NULL;	// otherwise the player may be set as YOU

  	// launch shell
	weapLaunch00_shell_data[0] = weapLaunch00_template[weap_offset + weapLaunch00_weap_speed]; // launch speed
	weapLaunch00_shell_data[1] = weapLaunch00_template[weap_offset + weapLaunch00_weap_grav];  // gravity effect
	weapLaunch00_shell_data[2] = weapLaunch00_template[weap_offset + weapLaunch00_weap_damage];// base damage
	weapLaunch00_shell_data[3] = weapLaunch00_template[weap_offset + weapLaunch00_weap_radius];// blast radius

	WeapLaunch00_Fire_AngleA(weapLaunch00_template[weap_offset + weapLaunch00_weap_shell]);


	// play weapon launch noise
	WeaponFX00_Play_Shot(my,weapLaunch00_template[weap_offset + weapLaunch00_weap_snd]);

}



////////////////////////////////////////////////////////////////////////
// Desc: Fire the current weapon
//
// Note: Make sure weapon is facing player before firing (otherwise it will look strange)
function	AIFPS01_Fire()
{
	var weap_offset; 	// used to store the weapon offset

	if(my._weapon_id__029>=100)
	{
		return(AIFPS01_LauncherFire());

	}

ifdef	aiFPS01_perform_report;
  timer(); // reset timer
  aiFPS01_fire_calls += 1;	// reset counter
endif;
	// fire gun

	if(my._weapon_vertex__029 <= 0)
	{
		// use model center
		vec_set(weapons00_from_vec,my.x);
	}
	else
	{
		// use weapon vertex
		vec_for_vertex(weapons00_from_vec, my, my._weapon_vertex__029);
	}

	// calculate vector to player
	vec_diff(temp,plSelect_curr_ent.x,weapons00_from_vec);
	vec_to_angle(weapons00_to_vec,temp);

	// fx comes from the same area shoot comes from
	vec_set(weapons00_fx_vec,weapons00_from_vec);

	// get offset
	weap_offset = (my._weapon_id__029*weapons00_weap_field_count);

	// reload time
	my._reload_ticks__029 = weapons00_template[weap_offset + weapons00_weap_cycle] + my._weapon_reload_mod__029;

	// fire weapon with param: accuracy,range,damage,gun_fx
	Weapons00_Gun_Fire_AngleA( weapons00_template[weap_offset + weapons00_weap_acc] + my._weapon_acc_mod__029,
							  	  		weapons00_template[weap_offset + weapons00_weap_range],
							  	  		weapons00_template[weap_offset + weapons00_weap_damage],
							  	  		weapons00_template[weap_offset + weapons00_weap_fx] );


	// play weapon noise
	WeaponFX00_Play_Shot(my,weapons00_template[weap_offset + weapons00_weap_snd]);


ifdef	aiFPS01_perform_report;
  aiFPS01_fire_time += timer(); // processor time used
endif;

}


/////////////////////////////////////////////////////////////
// Desc: 'look' for player
//
// Return: 2 if the player is in the sight range/fov
//			  0 otherwise
//
// Note: if return value = 2, temp = angle from my to player.
function	AIFPS01_Look()
{
ifdef	aiFPS01_perform_report;
  timer(); // reset timer
  aiFPS01_look_calls += 1;	// reset counter
endif;
	// in fov?
	if(vec_dist(my.x,plSelect_curr_ent.x) < my._sight_range__029)
	{
 		// in range, check angle
		vec_set(gid01_vec,plSelect_curr_ent.x);
		vec_sub(gid01_vec,my.x);
		vec_set(temp,my.x);
		vec_to_angle(temp,gid01_vec);
		if(abs(ang(temp.pan-my.pan)) < my._fov__029)    // only pan
		{
			// Trace to player
			trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS + IGNORE_MODELS;
 			c_trace(my.x,plSelect_curr_ent.x,trace_mode);
ifdef	aiFPS01_perform_report;
  aiFPS01_look_elapsed += timer(); // processor time used
endif;
	  		if((you == plSelect_curr_ent) || (trace_hit == 0))      // ??? HACK: you should equal the target
			{
				return(2);
			}
ifdef aiFPS01_show_health;
			else
			{
		draw_text("HIDDEN",300,400,vector(200,100,255));
			}
endif;
		}
ifdef aiFPS01_show_health;
		else
		{
	draw_text("OUT OF LOOK CONE",300,400,vector(100,100,255));
		}
endif;
	}
ifdef aiFPS01_show_health;
	else
	{
draw_text("OUT OF LOOK RANGE",300,400,vector(100,100,255));
	}
endif;
	return(0);
}

//////////////////////////////////////////////////////////////
// Desc: 'listen' for player
//
// Return: 1 if the player is in the hearing range
//			  0 otherwise
function	AIFPS01_Listen()
{
	if(vec_dist(my.x,plSelect_curr_ent.x) < my._hearing__029)
	{
		return(1);
	}
	return(0);
}


//////////////////////////////////////////////////////////////
// Desc: scan for player, first 'hear' then 'look'
//
// Return: 1 if "hear", 2 if "see", 0 otherwise
//
// Assume: plSelect_curr_ent is valid
//			  my is a aiFPS01 entity
//			  my._hearing__029 < my._sight_range__029
//
// Note: if 1 or 2 returned then temp = angle to player (pan,tilt) + range (roll)
function	AIFPS01_Scan()
{
	var	dist;
	dist = vec_dist(my.x,plSelect_curr_ent.x);

	// in fov?
	if(dist < my._sight_range__029)
	{
 		// in range, check angle
		vec_set(gid01_vec,plSelect_curr_ent.x);
		vec_sub(gid01_vec,my.x);
		vec_set(temp,my.x);
		vec_to_angle(temp,gid01_vec);
		if(abs(ang(temp.pan-my.pan)) < my._fov__029)    // only pan
		{
			// Trace to player
			trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS;// + IGNORE_MODELS;
 			trace(my.x,plSelect_curr_ent.x);
			if(you == plSelect_curr_ent)
			{
				temp.roll = dist;	// store for use later...
				return(2);
			}
		}
		else
		{
			// can hear?
 			if(dist < my._hearing__029)
			{
				temp.roll = dist;	// store for use later...
				return(1);
			}
		}
	}

	return(0);
}



/////////////////////////////////////////
// Desc: wait state
//
// Called by: AIFPS01_Guard_Update
//
//
function	AIFPS01_Wait01()
{
	// WAIT state
ifdef aiFPS01_show_health;
draw_text("WAIT",300,300,vector(100,100,255));
endif;

	// Scan for player
	if(plSelect_curr_ent != 0) 	// we need a player to scan for!
	{
ifdef	aiFPS01_perform_report;
  timer(); // reset timer
  aiFPS01_scan_calls += 1;	// reset counter
endif;
		// do a scan..
		temp2 = AIFPS01_Scan();
ifdef	aiFPS01_perform_report;
  aiFPS01_look_elapsed += timer(); // processor time used
endif;

   	//try to detect player
		if(temp2 == 2)
		{
			//+++ play "see player noise"

			gid01_event_type = gid01_event_alert_sound;
			scan_entity(my.x,vector(360,30,aiFPS01_alert_range));  // alert others in ear-shot
			my._ai_state__029 = _aiFPS01_state_attack; // switch to attack
			return(_aiFPS01_state_attack);
		}
		else
		{
			if(temp2 == 1)
			{
				//+++ play "hear player noise"
				my._ai_state__029 = _aiFPS01_state_hunt; // switch to hunt mode
				return(_aiFPS01_state_hunt);
			}
		}
	}


	// We haven't seen or heard the player
	if(my._path_node__029 != 0)
	{
		// we are a path follower
		vec_set(gid01_vec,my._path_vec__029);
		vec_sub(gid01_vec,my.x);
		vec_to_angle(temp,gid01_vec);
		gid01_vec.z = 0;	// ignore the z value
		if(vec_length(gid01_vec) < 25)
		{
 			AIFPS01_PathOnNode();	// preform node action
		}
		aiFPS01_Move(temp.pan, my._max_force_x__003/2);
	}
	else
	{
		// stand there
		vec_set(my._cur_force_x__029,nullvector);
		vec_set(my._cur_ang_force_pan__029,nullvector);
	}

}


////////////////////////////////////////////////////////
// Desc: hunt down the player
function	AIFPS01_Hunt01()
{
ifdef aiFPS01_show_health;
draw_text("HUNT FOR PLAYER",300,350,vector(100,100,255));
endif;
	if(plSelect_curr_ent != 0)
	{
    	// see player?
		if(AIFPS01_Look() != 0)
		{
			my._ai_state__029 = _aiFPS01_state_attack; // switch to attack

			//+++ play "see player noise"

			gid01_event_type = gid01_event_alert_sound;
			scan_entity(my.x,vector(360,30,aiFPS01_alert_range));  // alert others in ear-shot
		}
		else
		{
			// move forward, half speed
			aiFPS01_Move(my.pan, my._max_force_x__003);
		}
	}
}




////////////////////////////////////////////////////////
// Desc: attack state
//
// Called by: AIFPS01_Guard_Update
function	AIFPS01_Attack01()
{
	// ATTACK STATE
ifdef aiFPS01_show_health;
draw_text("ATTACK",300,300,vector(100,100,255));
endif;

ifdef	aiFPS01_perform_report;
  timer(); // reset timer
  aiFPS01_scan_calls += 1;	// reset counter
endif;
	// do a scan..
	temp2 = AIFPS01_Scan();
ifdef	aiFPS01_perform_report;
  aiFPS01_look_elapsed += timer(); // processor time used
endif;

	if(temp2 == 0)
	{
		// lost player..
		my._ai_state__029 = _aiFPS01_state_hunt; // switch to 'hunt' mode
	}
	else
	{
		if((temp2 == 1) // only hear player?
		  || (temp[2] > my._sight_range__029)) // or out of sight range?
		{
			// we can just hear them...
ifdef aiFPS01_show_health;
draw_text("HEAR PLAYER",300,350,vector(100,100,255));
endif;
			// turn towards player and try to reacquire them visually...
			AIFPS01_PanTo(temp.pan);
			// stand there
			vec_set(my._cur_force_x__029,nullvector);

			my._ai_state__029 = _aiFPS01_state_hunt; // switch to 'hunt' mode
		}
		else
		{
			if(temp2 == 2) // see player?
			{
ifdef aiFPS01_show_health;
draw_text("SEE PLAYER",300,350,vector(100,100,255));
endif;
 				// turn towards player...
				AIFPS01_PanTo(temp.pan);

				if(my._reload_ticks__029 <= 0)
				{
 					// Fire weapon (if able)
					MY._biped01_state2_mod = biped01_state2_mod_attack_const;  // reset in bipedAnim01
					AIFPS01_Fire();
				}
				else
				{
					// reload if not firing...
 					my._reload_ticks__029 -= time_step;

					// move to a certain range...
					if(temp[2] > aiFPS01_min_range)
					{
						// approach
						vec_set(my._cur_force_x__029,vector(my._max_force_x__003,0,0));
					}
					else
					{
						// do not approach
						vec_set(my._cur_force_x__029,nullvector);
					}

				}

			}
		}
	}
}






//----------------------------------------------------------------------
// Desc: Format the animation values (using defaults as neccessary).
function	AIFPS01_Set_Animation()
{
	if(my._walkswim_dist__002 == 0)   // walk distance . swim distance
	{
		my._walkswim_dist__002 = 4.04;
	}
	if(my._runcrawl_dist__002 == 0)   // run distance . crawl distance
	{
		my._runcrawl_dist__002 = 6.03;
	}
	if(my._standjump_time__002 == 0)   // stand time . jump time
	{
		my._standjump_time__002 = 4.02;
	}
	if(my._attackduck_time__002 == 0)   // attack time . duck time
	{
		my._attackduck_time__002 = 4.02;
	}
	if(my._deathdamage_time__002 == 0)   // death time . damage time
	{
		my._deathdamage_time__002 = 12.02;
	}
	if(my._runthreshold__002 == 0)	// run threshold
	{
		my._runthreshold__002 = 12;
	}
}



// =====================================================================
// Guard Code

// Desc: update guard (call once per frame while active)
function	AIFPS01_Guard_Update()
{
	// start in wait state
	my._ai_state__029 = _aiFPS01_state_wait;


	while(1)
	{
		// Handle "state" related activities
		if(my._ai_state__029 == _aiFPS01_state_wait)
		{
			AIFPS01_Wait01();
		} // end WAIT STATE
		else
		{
			if(my._ai_state__029 == _aiFPS01_state_attack)
			{
				AIFPS01_Attack01();
			}  // END ATTACK STATE
			else
			{
				if(my._ai_state__029 == _aiFPS01_state_hunt)
				{
					AIFPS01_Hunt01();
				}
				else
				{
diag("\n\nBUG! State not correct in AIFPS01_Guard_Update!!!\n");
					AIFPS01_Wait01(); // when all else fails, do nothing(?)
				}
			}
		}


		// Send forces/flags to biped01 update (which will handle physics, animation, and sound)
		if((vec_length(my._cur_force_x__029) >0) || (vec_length(my._cur_ang_force_pan__029) >0)
			|| (vec_length(my._gid01_vel_x) >0))
		{
			BipedPhy01_Update(my._cur_force_x__029, my._cur_ang_force_pan__029);
		}

		// Handle drowning damage
		if(my._biped01_state_mod == biped01_state_mod_drown_const)
		{
			// handle any damage from drowning (time based)
			my._health__003 -= bipedPhy01_drowning_damage_const*time_step;
		}

		// Handle Death
		if(my._health__003 <= 0)
		{
			if(my._explode__029 == ON)
			{
				// exploding robot death

 				proc_kill(1);	// stop the other functions spawned by this entity
				wait(1);       // ...let them finish their run

				// EXPLODE!
				temp = (my.max_x - my.min_x) * 3;
				ent_create(weapLaunch00_expl_str, my.x, WeaponFX00_Anim_Explode);

				wait(1);
				ent_remove(me);
				return;
 			}
			else
			{
				// "Flesh-bag" death

				my._biped01_state = biped01_state_dying_const;
				my.passable = ON;
				sleep(3);

				ifdef aiFPS01_show_blood;
					// blood pool on floor
					trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS + IGNORE_MODELS;
					c_trace(my.x,vector(my.x,my.y,my.z-100),trace_mode);
					// todo: use c_trace and check to make sure we hit something
					if(trace_hit == 1)
					{
						ent_create(fxGore01_bloodpool_str,target,FXGore01_Bloodpool);
					}
				endif;


				sleep(10);
				// fade and remove
				my.transparent = on;
				my.alpha = 100;
				while(my.alpha > 0)
				{
					my.alpha -= 3*time_step;
					wait(1);
				}
			proc_kill(1);	// stop the other functions spawned by this entity
			wait(1);       // ...let them finish their run
			ent_remove(me);
			return;
			}
		}



ifdef aiFPS01_show_health;
	var	temp_vec[3];
	vec_set(temp_vec,my.x);
	if(vec_to_screen(temp_vec,camera))
	{
		str_for_num(aiFPS01_str,my._health__003);
		draw_text(aiFPS01_str,temp_vec.x,temp_vec.y,vector(100,100,255));
	}
endif;
		wait(1);
	}

}

//----------------------------------------------------------------------
// Desc: handle guard events
function AIFPS01_Guard_Event()
{
ifdef	aiFPS01_perform_report;
  timer(); // reset timer
  aiFPS01_event_calls += 1;	// reset counter
endif;

	if((EVENT_TYPE == event_shoot) && (gid01_event_type == gid01_event_projectile_damage))
	{
		if(my._armor__003 > 0)
		{
			my._armor__003 -= gid01_event_value;
			ifdef aiFPS01_show_sparks;
				effect(FXGore01_Sparks,random(50)+10,target.x,nullvector);
			endif;
		}
		else
		{  // take flesh damage
			my._health__003 -= gid01_event_value;

			ifdef aiFPS01_show_blood;
				if(my._explode__029 == ON)
				{
					// allows you to have "robot entities" with 1 health that will not bleed (use armor instead)
					if(my._health__003 > 1)
					{
   					effect(FXGore01_BloodSpray,random(20)+10,target.x,nullvector);
					}

				}
				else
				{
					effect(FXGore01_BloodSpray,random(20)+10,target.x,nullvector);
				}
			endif;
		}

		if( my._ai_state__029 == _aiFPS01_state_wait) // doesn't know about the player yet?
		{
			my._ai_state__029 = _aiFPS01_state_hunt;  // be alert to the player
		}
	}


	// handle scan events
	if(EVENT_SCAN == EVENT_TYPE)
	{
		if(gid01_event_blast_damage == gid01_event_type)
		{

			// trace back to the blast source
			if(1) // ++ fix c_trace(your.x,my.x,(ignore_me+ignore_you+ignore_passable+ignore_passents)) == 0)
			{
				if(my._armor__003 > 0)
				{
					my._armor__003 -= gid01_event_value;
					if(my._armor__003 < 0)
					{
						// flesh damage after armor damage
						my._health__003 += my._armor__003;
						my._armor__003 = 0;
					}
				}
				else
				{  // take flesh damage
					my._health__003 -= gid01_event_value;
				}

				if( my._ai_state__029 == _aiFPS01_state_wait) // doesn't know about the player yet?
				{
					my._ai_state__029 = _aiFPS01_state_hunt;  // be alert to the player
				}
			}
		}


		if(gid01_event_alert_sound == gid01_event_type)
		{
			if( my._ai_state__029 == _aiFPS01_state_wait) // doesn't know about the player yet?
			{
				// guard has heard an alert noise
	 			my._ai_state__029 = _aiFPS01_state_hunt; // switch to 'hunt' mode
			}
		}
	}
ifdef	aiFPS01_perform_report;
  aiFPS01_event_time = timer(); // reset timer
endif;

}


//----------------------------------------------------------------------

// action: AIFPS01_Guard
// title: FPS Guard
// Desc: Simple "guard" AI. Attach to a "biped" model entity in your level.
// Desc: AI can be armed with any weapon defined in weapons00.
// Desc: It can also be attached to a path in WED, which it will patrol until it detects the player.
///		Four "states":
///		-	Waiting: Doesn't move until he detects the player (or follow path).
///		-	Attack: Moves towards the player, firing his weapon.
///		-  Hunting: Scan for player
///		-	Dying: Stops all movement, plays death animation, removes self.
//	Note: Good AI for simple tasks like guarding doors.
//
// uses _max_force_x__003, _max_force_y__003
// uses _max_ang_force_pan__003
// uses _weapon_vertex__029, _weapon_id__029, _weapon_acc_mod__029,
// uses _fov__029, _hearing__029
// uses _move_min_z__003,_jump_height__003, _duck_height__003
// uses _walkswim_dist__002, _runcrawl_dist__002, _standjump_time__002
// uses _attackduck_time__002, _deathdamage_time__002, _runthreshold__002
// uses _health__003, _armor__003, _explode__029
//
//------------------
// section: Heath & Armor
//	skill1: Health 25
// cntl: spin 1 x 5
// help: Reduced by damage. When <=0, AI dies.
//
//	skill2: Armor 0
// cntl: spin 0 x 5
// help: Reduces the damage that would otherwise be taken from health.
//
// flag5: Explode? 0
// help: If selected, AI explodes on death
//
//------------------
// section: Movement
// skill3: ForceX 3.5
// help: Forward force used to calculate AI speed.
// cntl: spin 0 x 0.25
//
// skill4: ForceY 1.75
// help: Force used to calculate AI "side-step" speed.
// cntl: spin 0 x 0.25
//
// skill6: Pan 10
// help: Force used to calculate the AI's rotation speed.
// cntl: spin 0 x 0.25
//
//------------------
// section: Limits
//
// skill9: MinMoveZ 0.55
// help: Used to adjust the amount of upward sliding the AI can do.
// help: 0-can slide up onto anything under half its height, 0.99 no upward sliding.
// cntl: spin 0 0.99 0.05
//
// skill10: Jump 75
// help: Height that the AI tries to jump to.
// cntl: spin 0 x 1
//
// flag1: NoFallDamage 0
// help: If set, player takes no falling damage.
//
//------------------
// section: Animation
// skill12: WalkSwimDist 4.04
// help: Walk.Swim animation cycle distance.
// cntl: spin 0 x 1
//
// skill13: RunCrawlDist 6.03
// help: Run.Crawl animation cycle distance.
// cntl: spin 0 x 1
//
// skill14: StandJumpTime 4.02
// help: Time in Stand.Jump animation cycle.
// cntl: spin 0 x 1
//
// skill15: AttackDuckTime 4.02
// help: Time in Attack.Duck animation cycle.
// cntl: spin 0 x 1
//
// skill16: DeathDamageTime 12.02
// help: Time in Death.Damage animation cycle.
// cntl: spin 0 x 1
//
// skill17: RunThreshold 12
// help: If AI is moving faster then this many quants,
// help:use running animation, otherwise use walking.
// cntl: spin 1 x 1
//
// ----------------------------------------
// section: Weapon
// skill18: ID 1
// help: id index of weapon used
//
// skill19: Vertex -1
// help: Model vertex that weapon fire comes from (-1: model center)
// cntl: spin -1 x 1
//
// skill20: AccReload 3.024
// help: Accuracy modifier added (or removed) and reload modfifier (acc.ticks)
//
// ----------------------------------------
// section: Senses
//
// skill7: FOV  2000.090
// help: Field of view (range.deg)
//
// skill8: Hearing  100
// help: Hearing range
action	AIFPS01_Guard
{
	my._gid01_id = gid01_ai_const;	// set ID to generic AI type

	// setup for collision
	wait(1);
	BipedPhy01_Setup_Ent();


	// set up event handler
	my.event = AIFPS01_Guard_Event;	// handle events
	my.enable_shoot = on;  	// gun shoot
	my.enable_scan = on;		// explosions, alerts


	// default biped values
	if(my._health__003 == 0) { my._health__003 = 25; }
	//if(my._armor__003 == 0) { my._health__003 = 0; }
	if(my._max_force_x__003 == 0) { my._max_force_x__003 = 2.5; }
	if(my._max_force_x__003 < 0) {  my._max_force_x__003 = 0; }    // neg value = no force
	if(my._max_force_y__003 == 0) { my._max_force_y__003 = 0.75; }
	if(my._max_force_y__003 < 0) {  my._max_force_y__003 = 0; }    // neg value = no force
	if(my._max_ang_force_pan__003 == 0) { my._max_ang_force_pan__003 = 5; }
	if(my._max_ang_force_pan__003 < 0) {  my._max_ang_force_pan__003 = 0; }    // neg value = no force

	//if(my._jump_height__003 == 0) { my._jump_height__003 = 0; }
	//if(my._duck_height__003 == 0) { my._duck_height__003 = 0; }
	// upward glide
	if(my._move_min_z__003 > 0.99)
	{
		my._move_min_z__003 = 0.99;
	}
	if(my._move_min_z__003 < 0)
	{
 		my._move_min_z__003 = 0;
	}

	// default guard values
	// WEAPON
	my._weapon_id__029 = int(my._weapon_id__029 - 1);
	if(my._weapon_id__029 < 0) { my._weapon_id__029 = 0; } // id of weapon used
	else
	{
 		if(my._weapon_id__029 < 100) // 100+ is a launcher weapon
		{
			if(my._weapon_id__029 >= weapons00_weap_count) { my._weapon_id__029 = weapons00_weap_count-1; }
		}
		else
		{
			if((my._weapon_id__029 - 100) >= weapLaunch00_weap_count) { my._weapon_id__029 = 100+(weapLaunch00_weap_count-1); }
		}
	}
	if(my._weapon_vertex__029 == 0) { my._weapon_vertex__029 = -1; }  // use model origin

	my._weapon_reload_mod__029 = abs(frc(my._weapon_acc_mod__029) * 1000);   // reload modifier
//---	if(my._weapon_reload_mod__029 == 0) { my._weapon_reload_mod__029 = 24; } // 16 ticks (1 second)
	my._weapon_acc_mod__029 = int(my._weapon_acc_mod__029);             					// accuracy modifier


	// SENSES
	if(my._fov__029 == 0) { my._fov__029 = 2000.090; }	// field of view (range.deg)
	else
	{
		if(int(my._fov__029 == 0)) { my._fov__029 += 2000; } // missing range
		if(frc(my._fov__029 == 0)) { my._fov__029 += 0.090; } // missing fov
	}
	if(my._hearing__029 == 0) { my._hearing__029 = 100; }			// 'hearing' range

	// set the vector used by scan_entity
	my._sight_range__029 = int(my._fov__029);
	temp = frc(my._fov__029) * 500; // 1000/2;
	if(temp > 180) { temp = 180; }
	if(temp <= 0) { temp = 45; }
	my._fov__029 = temp;

	AIFPS01_Set_Animation();	// set the animation values for this AI


	// Start the animation update loop (runs until biped is removed)
	BipedAnim01_Update_Loop();
	// Start the sound loop (runs until biped is removed)
	BipedSnd01_Update_Loop();

	// Check for path
	if(path_getnode(my,1,my._path_vec__029,aifps01_path_skills) != 0)
	{
		my._path_node__029 = 1;		// start at first node
		while(aifps01_path_skills[5] != 0) // someone is using this node
		{
			my._path_node__029 += 1; // goto next node
			if(path_getnode(my,my._path_node__029,my._path_vec__029,aifps01_path_skills) == 0)
			{
				// no room in path!
				my._path_node__029 = 0;
				break;
			}
		}


		if(my._path_node__029 != 0) // we have a valid node in a path
		{
			// move to start
			//path_nodepos(my,my._path_node__029,my.x);
			vec_set(my.x,my._path_vec__029);

			// mark this node as occupied
			aifps01_path_skills[5] = handle(my);

			// set this as the current waypoint
			path_setnode(my,my._path_node__029,my._path_vec__029,aifps01_path_skills);
		}

		wait(1);	// we should wait at least one frame so other pathfollow entities can see that we own this node during setup
	}
	else
	{
		// since AI doesn't call phy_update unless there are forces to calculate
		BipedPhy01_Update(nullvector,nullvector); // setup environ forces
	}


	// Call the update loop
	AIFPS01_Guard_Update();

}




//----------------------------------------------------------------------

// Desc: update hover AI (call once per frame while active)
function	AIFPS01_Hover_Update()
{
	// start in wait state
	my._ai_state__029 = _aiFPS01_state_wait;


	while(1)
	{
		// Handle "state" related activities
		if(my._ai_state__029 == _aiFPS01_state_wait)
		{
			AIFPS01_Wait01();
		} // end WAIT STATE
		else
		{
			if(my._ai_state__029 == _aiFPS01_state_attack)
			{
				AIFPS01_Attack01();
			}  // END ATTACK STATE
			else
			{
				if(my._ai_state__029 == _aiFPS01_state_hunt)
				{
					AIFPS01_Hunt01();
				}
				else
				{
diag("\n\nBUG! State not correct in AIFPS01_Guard_Update!!!\n");
					AIFPS01_Wait01(); // when all else fails, do nothing(?)
				}
			}
		}


		// Send forces/flags to biped01 update (which will handle physics, animation, and sound)
 		// Replaces the call to "BipedPhy01_Update(aiFPS01_force_vec, aiFPS01_ang_force_vec.pan);"
		my.pan += my._cur_ang_force_pan__029;
 		temp.x = c_trace(my.x,vector(my.x,my.y,(my.z - 10000)),ignore_me);
		if(0 != trace_hit) // something hit
		{
			temp.x = temp.x - my._height__029;
			// maintain height
			if(temp.x > 0)
			{
				my._cur_force_z__029 = -my._max_force_y__003;
			}
			else
			{
				my._cur_force_z__029 = -(my._max_force_y__003 * temp.x/my._height__029);
			}
		}
		else
		{
			my._cur_force_z__029 = -my._max_force_y__003;
		}
		vec_accelerate(temp,my._gid01_vel_x,my._cur_force_x__029,0.5);

		c_move(my,temp,vector(0,0,0),GLIDE+IGNORE_PASSABLE+IGNORE_PASSENTS);

		// animation
		my._biped01_state = biped01_state_walk_const;

		// Handle Death
		while(my._health__003 <= 0)
		{
			my._biped01_state = biped01_state_dying_const;

			// crash down to floor and explode
			my.pan += 10*time_step;
			my.roll += 3.5*time_step;

			vec_set(my._cur_force_x__029,vector(0,0,-my._max_force_y__003));

			vec_accelerate(temp,my._gid01_vel_x,my._cur_force_x__029,0.5);
			c_move(my,vector(0,0,0),temp,GLIDE+IGNORE_PASSABLE+IGNORE_PASSENTS);

			// drop flame2smoke
			if(random(8) < 3)
			{
				temp.x = random(4) - (2);
				temp.y = random(4) - (2);
				temp.z = random(4);
				effect(FXA_Exp1_FX,1,my.x,temp);
			}


			if(0 != trace_hit) // something hit
			{
 				proc_kill(1);	// stop the other functions spawned by this entity
				wait(1);       // ...let them finish their run

				// EXPLODE!
				temp = (my.max_x - my.min_x) * 3;
				ent_create(weapLaunch00_expl_str, my.x, WeaponFX00_Anim_Explode);

				wait(1);
				ent_remove(me);
				return;
 			}

			wait(1);
		}



ifdef aiFPS01_show_health;
	var	temp_vec[3];
	vec_set(temp_vec,my.x);
	if(vec_to_screen(temp_vec,camera))
	{
		str_for_num(aiFPS01_str,my._health__003);
		draw_text(aiFPS01_str,temp_vec.x,temp_vec.y,vector(100,100,255));
	}
endif;
		wait(1);
	}

}



// action: AIFPS01_Hover
// title: Hovercraft
// Desc: "Hovering" AI.
///		Four "states":
///		-	Waiting: Doesn't move until he detects the player (or follow path).
///		-	Attack: Moves towards the player, firing his weapon.
///		-  Hunting: Scan for player
///		-	Dying: Stops all movement, plays death animation, removes self.
//
// uses _max_force_x__003, _max_force_y__003
// uses _max_ang_force_pan__003
// uses _weapon_vertex__029, _weapon_id__029, _weapon_acc_mod__029,
// uses _fov__029, _hearing__029
// uses _move_min_z__003,_jump_height__003, _duck_height__003
// uses _walkswim_dist__002, _runcrawl_dist__002, _standjump_time__002
// uses _attackduck_time__002, _deathdamage_time__002, _runthreshold__002
// uses _health__003, _armor__003, _explode__029
//
//------------------
// section: Heath & Armor
//	skill1: Health 1
// cntl: spin 1 x 5
// help: Reduced by damage. When <=0, AI dies.
//
//	skill2: Armor 24
// cntl: spin 0 x 5
// help: Reduces the damage that would otherwise be taken from health.
//
// flag5: Explode? 1
// help: If selected, AI explodes on death
//
//------------------
// section: Movement
// skill3: ForceX 3.5
// help: Forward force used to calculate AI speed.
// cntl: spin 0 x 0.25
//
// skill4: ForceY 1.75
// help: Force used to calculate AI "side-step" speed.
// cntl: spin 0 x 0.25
//
// skill6: Pan 10
// help: Force used to calculate the AI's rotation speed.
// cntl: spin 0 x 0.25
//
//------------------
// section: Limits
//
// skill9: MinMoveZ 0.55
// help: Used to adjust the amount of upward sliding the AI can do.
// help: 0-can slide up onto anything under half its height, 0.99 no upward sliding.
// cntl: spin 0 0.99 0.05
//
// skill10: Jump 75
// help: Height that the AI tries to jump to.
// cntl: spin 0 x 1
//
// flag1: NoFallDamage 0
// help: If set, player takes no falling damage.
//
//------------------
// section: Animation
// skill12: WalkSwimDist 4.04
// help: Walk.Swim animation cycle distance.
// cntl: spin 0 x 1
//
// skill13: RunCrawlDist 6.03
// help: Run.Crawl animation cycle distance.
// cntl: spin 0 x 1
//
// skill14: StandJumpTime 4.02
// help: Time in Stand.Jump animation cycle.
// cntl: spin 0 x 1
//
// skill15: AttackDuckTime 4.02
// help: Time in Attack.Duck animation cycle.
// cntl: spin 0 x 1
//
// skill16: DeathDamageTime 12.02
// help: Time in Death.Damage animation cycle.
// cntl: spin 0 x 1
//
// skill17: RunThreshold 12
// help: If AI is moving faster then this many quants,
// help:use running animation, otherwise use walking.
// cntl: spin 1 x 1
//
// ----------------------------------------
// section: Weapon
// skill18: ID 1
// help: id index of weapon used
//
// skill19: Vertex -1
// help: Model vertex that weapon fire comes from (-1: model center)
// cntl: spin -1 x 1
//
// skill20: AccReload 3.024
// help: Accuracy modifier added (or removed) and reload modfifier (acc.ticks)
//
// ----------------------------------------
// section: Senses
//
// skill7: FOV  2000.090
// help: Field of view (range.deg)
//
// skill8: Hearing  100
// help: Hearing range
action	AIFPS01_Hover
{
	my._gid01_id = gid01_ai_const;	// set ID to generic AI type

	// note: uses its own movement (not bipedPhy)
	wait(1);
	my.fat = ON; my.narrow = ON;
	c_setminmax(my);

 	// set up event handler
	my.event = AIFPS01_Guard_Event;	// handle events
	my.enable_shoot = on;  	// gun shoot
	my.enable_scan = on;		// explosions, alerts


	// default biped values
	if(my._health__003 == 0) { my._health__003 = 1; }
	//if(my._armor__003 == 0) { my._health__003 = 0; }
	if(my._max_force_x__003 == 0) { my._max_force_x__003 = 2.5; }
	if(my._max_force_x__003 < 0) {  my._max_force_x__003 = 0; }    // neg value = no force
	if(my._max_force_y__003 == 0) { my._max_force_y__003 = 0.75; }
	if(my._max_force_y__003 < 0) {  my._max_force_y__003 = 0; }    // neg value = no force
	if(my._max_ang_force_pan__003 == 0) { my._max_ang_force_pan__003 = 5; }
	if(my._max_ang_force_pan__003 < 0) {  my._max_ang_force_pan__003 = 0; }    // neg value = no force

	// set height (if one isn't already set)
	my._height__029 = c_trace(my.x,vector(my.x,my.y,(my.z - 10000)),ignore_me);
	if(0 == trace_hit) // 0-if nothing hit
	{
		my._height__029 = 10000;
	}


	//if(my._jump_height__003 == 0) { my._jump_height__003 = 0; }
	//if(my._duck_height__003 == 0) { my._duck_height__003 = 0; }
	// upward glide
	if(my._move_min_z__003 > 0.99)
	{
		my._move_min_z__003 = 0.99;
	}
	if(my._move_min_z__003 < 0)
	{
 		my._move_min_z__003 = 0;
	}

	// default guard values
	// WEAPON
	my._weapon_id__029 = int(my._weapon_id__029 - 1);
	if(my._weapon_id__029 < 0) { my._weapon_id__029 = 0; } // id of weapon used
	else
	{
		if(my._weapon_id__029 >= weapons00_weap_count) { my._weapon_id__029 = weapons00_weap_count-1; }
	}
	if(my._weapon_vertex__029 == 0) { my._weapon_vertex__029 = -1; }  // use model origin

	my._weapon_reload_mod__029 = abs(frc(my._weapon_acc_mod__029) * 1000);   // reload modifier
//---	if(my._weapon_reload_mod__029 == 0) { my._weapon_reload_mod__029 = 24; } // 16 ticks (1 second)
	my._weapon_acc_mod__029 = int(my._weapon_acc_mod__029);             					// accuracy modifier


	// SENSES
	if(my._fov__029 == 0) { my._fov__029 = 2000.090; }	// field of view (range.deg)
	else
	{
		if(int(my._fov__029 == 0)) { my._fov__029 += 2000; } // missing range
		if(frc(my._fov__029 == 0)) { my._fov__029 += 0.090; } // missing fov
	}
	if(my._hearing__029 == 0) { my._hearing__029 = 100; }			// 'hearing' range

	// set the vector used by scan_entity
	my._sight_range__029 = int(my._fov__029);
	temp = frc(my._fov__029) * 500; // 1000/2;
	if(temp > 180) { temp = 180; }
	if(temp <= 0) { temp = 45; }
	my._fov__029 = temp;

	AIFPS01_Set_Animation();	// set the animation values for this AI


	// Start the animation update loop (runs until biped is removed)
	BipedAnim01_Update_Loop();
	// Start the sound loop (runs until biped is removed)
	BipedSnd01_Update_Loop();

	// Check for path
	if(path_getnode(my,1,my._path_vec__029,aifps01_path_skills) != 0)
	{
		my._path_node__029 = 1;		// start at first node
		while(aifps01_path_skills[5] != 0) // someone is using this node
		{
			my._path_node__029 += 1; // goto next node
			if(path_getnode(my,my._path_node__029,my._path_vec__029,aifps01_path_skills) == 0)
			{
				// no room in path!
				my._path_node__029 = 0;
				break;
			}
		}


		if(my._path_node__029 != 0) // we have a valid node in a path
		{
			// move to start
			//path_nodepos(my,my._path_node__029,my.x);
			vec_set(my.x,my._path_vec__029);

			// mark this node as occupied
			aifps01_path_skills[5] = handle(my);

			// set this as the current waypoint
			path_setnode(my,my._path_node__029,my._path_vec__029,aifps01_path_skills);
		}

		wait(1);	// we should wait at least one frame so other pathfollow entities can see that we own this node during setup
	}


	// Call the update loop
	AIFPS01_Hover_Update();

}



endif;